#include "utl.h"
using namespace std;

double max(double x,double y){
  return (x > y ? x : y);
}


double min(double x,double y){
  return (x < y ? x : y);
}



  string Str(double x)   {
    stringstream ss;
    ss << x;
    return ss.str();
  }

  string Str(float x)   {
    stringstream ss;
    ss << x;
    return ss.str();
  }

//   string Str(size_t x)   {
//     stringstream ss;
//     ss << x;
//     return ss.str();
//   }

  string Str(int x)   {
    stringstream ss;
    ss << x;
    return ss.str();
  }

  string Str(unsigned int x)   {
    stringstream ss;
    ss << x;
    return ss.str();
  }


void StringToTextFile(string sText, string filePath) {
    ofstream outfile(filePath.c_str());
    outfile << sText;
  }


std::string TextFileToString(string  filePath)
  {
    string s, sText="";

    ifstream infile(filePath.c_str()); 
    
    if (!infile) {                     
      cout << "Error in utl_file::TextFileToString() - could not open file " << filePath << " <br/>\n";
      return sText;
    }

    while (getline(infile,s))
      sText += s + "\n";
    return sText;
  }

double GetMean(std::vector<double> v){
   int n=v.size();
  double sum=0;
  for(int i=0;i<n;i++)sum+=v[i];
  double mean=sum/(double)n;
  return mean;
}
double GetVariance(std::vector<double> v){
  int n=v.size();
  //double sum=0;
  //for(int i=0;i<n;i++)sum+=v[i];
  //double mean=sum/(double)n;
  double mean=GetMean(v);
  double std_sum=0;
  for(int i=0;i<n;i++) std_sum+=(v[i]-mean)*(v[i]-mean);
  //  double std=sqrt(std_sum/(double)n);
  double var=std_sum/(double)n;
  return var;
}




